include( "shared.lua" )

ENT.Radar = NULL
ENT.RadarPos = vector_origin

function ENT:GiveRadar( )
	local lpos
	
	lpos = self.ValidModels[ self:GetModel( ) ]
	
	if lpos then
		self.RadarPos = lpos
	end
	
	self.HasRadar = true
	
	self.Radar = ClientsideModel( "models/props_citizen_tech/transponder.mdl", RENDERGROUP_OPAQUE )
	self.Radar:SetNoDraw( true )
end

function ENT:Draw( )
	self:DrawModel( )
	
	if not ValidEntity( self.Radar ) then
		return
	end
	
	self.Radar:SetRenderOrigin( self:LocalToWorld( self.RadarPos ) )
	self.Radar:SetRenderAngles( self:GetAngles( ) )
	self.Radar:DrawModel( )
end

function ENT:Think( )
	if not ValidEntity( self.Radar ) and self:GetDTBool( 0 ) then
		self:GiveRadar( )
	end
end

local open_window = nil

local function umContentList( um )
	local form, container, take, x, lbl, id, gun, ammo1t, ammo1a, ammo2t, ammo2a, ammo3t, ammo3a, nothing
	
	if ValidEntity( open_window ) then
		open_window:Remove( )
		open_window = nil
	end
	
	gun = um:ReadString( )
	ammo1t = um:ReadString( )
	ammo1a = um:ReadShort( )
	
	ammo2t = um:ReadString( )
	ammo2a = um:ReadShort( )
	
	ammo3t = um:ReadString( )
	ammo3a = um:ReadShort( )
	
	id = um:ReadShort( )
	
	form = vgui.Create( "DFrame" )
	form:SetTitle( "Weapon Cache" )
	
	container = vgui.Create( "DPanelList", form )
	container:Dock( FILL )
	container:SetPadding( 5 )
	
	x = vgui.Create( "Panel" )
	
	nothing = true
	
	if gun ~= "" then
		lbl = Label( gun, x )
		lbl:SizeToContents( )
		lbl:Dock( LEFT )
		take = vgui.Create( "DButton", x )
		take:Dock( RIGHT )
		take:SetText( "Take" )
		function take:DoClick( )
			RunConsoleCommand( "cache_claim_item", id, "weapon" )
		end
		container:AddItem( x )
		nothing = false
	end
	
	if ammo1t ~= "" and ammo1a > 0 then
		x = vgui.Create( "Panel" )
		lbl = Label( string.format( "%s x %d", ammo1t, ammo1a ), x )
		lbl:SizeToContents( )
		lbl:Dock( LEFT )
		take = vgui.Create( "DButton", x )
		take:SetText( "Take" )
		function take:DoClick( )
			RunConsoleCommand( "cache_claim_item", id, "ammo1" )
		end
		take:Dock( RIGHT )
		container:AddItem( x )
		nothing = false
	end
	
	if ammo2t ~= "" and ammo2a > 0 then
		x = vgui.Create( "Panel" )
		lbl = Label( string.format( "%s x %d", ammo2t, ammo2a ), x )
		lbl:SizeToContents( )
		lbl:Dock( LEFT )
		take = vgui.Create( "DButton", x )
		take:SetText( "Take" )
		function take:DoClick( )
			RunConsoleCommand( "cache_claim_item", id, "ammo2" )
		end
		take:Dock( RIGHT )
		container:AddItem( x )
		nothing = false
	end
	
	if ammo3t ~= "" and ammo3a > 0 then
		x = vgui.Create( "Panel" )
		lbl = Label( string.format( "%s x %d", ammo3t, ammo3a ), x )
		lbl:SizeToContents( )
		lbl:Dock( LEFT )
		take = vgui.Create( "DButton", x )
		take:SetText( "Take" )
		function take:DoClick( )
			RunConsoleCommand( "cache_claim_item", id, "ammo3" )
		end
		take:Dock( RIGHT )
		container:AddItem( x )
		nothing = false
	end
	
	if nothing then
		form:Remove( )
		open_window = nil
	else
		form:SetSize( 320, 240 )
	
		form:Center( )
		form:MakePopup( )
		open_window = form
	end
end

usermessage.Hook( "ContentList", umContentList )