AddCSLuaFile( "shared.lua" )
AddCSLuaFile( "cl_init.lua" )

include( "shared.lua" )

umsg.PoolString( "ContentList" )

ENT.Contents = {
	Weapon = "",
	WeaponName = "",
	Ammo = {
		One = {
			Type = "none",
			Count = 0,
		},
		Two = {
			Type = "none",
			Count = 0,
		},
		Three = {
			Type = "none",
			Count = 0,
		},
	},
 }

function ENT:Initialize( )
	self:SetUseType( SIMPLE_USE )
end

function ENT:Create( mdl, pos, radar, contents )
	local phys
	self:SetModel( mdl )
	self:SetPos( pos + self:GetUp( ) * 64 )
	self:DropToFloor( )
	
	self:PhysicsInit( SOLID_VPHYSICS )
	self:SetMoveType( MOVETYPE_VPHYSICS )
	self:SetSolid( SOLID_VPHYSICS )
	
	phys = self:GetPhysicsObject( )

	if ValidEntity( phys ) then
		phys:Wake( )
	end
	
	self.Contents = contents
	
	self:SetDTBool( 0, radar )
end

function ENT:AssignWeapon( wep )
	self.Contents.Weapon = wep
end

function ENT:Use( pl )
	self:RequestContentList( pl )
end

function ENT:AssignAmmo( index, type, val )
	self.Contents.Ammo[ index ].Type = type
	self.Contents.Ammo[ index ].Count = val
end

function ENT:RequestContentList( pl )
	umsg.Start( "ContentList", pl )
		umsg.String( self.Contents.WeaponName )
		
		umsg.String( self.Contents.Ammo.One.Type )
		umsg.Short( self.Contents.Ammo.One.Count )
	
		umsg.String( self.Contents.Ammo.Two.Type )
		umsg.Short( self.Contents.Ammo.Two.Count )
	
		umsg.String( self.Contents.Ammo.Three.Type )
		umsg.Short( self.Contents.Ammo.Three.Count )
		
		umsg.Short( self:EntIndex( ) )
	umsg.End( )
end

function ENT.ClaimContents( pl, cmd, args )
	local self, id, tr
	
	id = tonumber( args[ 1 ] )
	
	if not id then
		return
	end
	
	self = Entity( id )
	
	if not ValidEntity( self ) or self:GetClass( ) ~= "weapon_cache" then
		return
	end
	
	if self:GetPos( ):Distance( pl:GetShootPos( ) ) > 200 then
		return
	end
	
	tr = util.TraceLine{ start = pl:GetShootPos( ), endpos = pl:GetShootPos( ) + pl:GetAimVector( ) * 200, filter = pl }
	
	if tr.Entity ~= self then
		return
	end
	
	if args[ 2 ] == "weapon" and self.Contents.Weapon ~= "" then
		pl:Give( self.Contents.Weapon )
		self.Contents.Weapon = ""
		self.Contents.WeaponName = ""
	end
	
	if args[ 2 ] == "ammo1" and self.Contents.Ammo.One.Count > 0 then
		pl:GiveAmmo( self.Contents.Ammo.One.Count, self.Contents.Ammo.One.Type )
		self.Contents.Ammo.One.Count = 0
	end
	
	if args[ 2 ] == "ammo2" and self.Contents.Ammo.Two.Count > 0 then
		pl:GiveAmmo( self.Contents.Ammo.Two.Count, self.Contents.Ammo.Two.Type )
		self.Contents.Ammo.Two.Count = 0
	end
	
	if args[ 2 ] == "ammo2" and self.Contents.Ammo.Three.Count > 0 then
		pl:GiveAmmo( self.Contents.Ammo.Three.Count, self.Contents.Ammo.Three.Type )
		self.Contents.Ammo.Three.Count = 0
	end
	
	self:RequestContentList( pl )
	
	if self.Contents.Ammo.One.Count == 0 and self.Contents.Ammo.Two.Count == 0 and self.Contents.Ammo.Three.Count == 0 and self.Contents.Weapon == "" then
		SafeRemoveEntity( self )		
	end
end

concommand.Add( "cache_claim_item", ENT.ClaimContents )