if SERVER then
	AddCSLuaFile( "shared.lua" )
end

SWEP.PrintName = "Portable Radar"
SWEP.Author = "Kogitsune"
SWEP.Instructions = "Watch the screen"

SWEP.Primary.Ammo = "none"
SWEP.Secondary.Ammo = "none"

SWEP.Spawnable = true

util.PrecacheModel( "models/props/de_inferno/tv_monitor01.mdl" )
util.PrecacheModel( "models/props_citizen_tech/transponder.mdl" )

SWEP.ViewModel = "models/props/de_inferno/tv_monitor01.mdl"
SWEP.WorldModel = "models/props/de_inferno/tv_monitor01.mdl"

SWEP.ViewModelFOV = 62

SWEP.Irons = {
	Normal = {
		Pos = Vector( -.4, -47.2, 3.5 ),
		Ang = Vector( -20.66, 180, 0 ),
	},
}

SWEP.Offset = {
	WorldModel = { 
		Pos = {
			Up = 0,
			Right = 0,
			Forward = 12,
		},
		Ang = {
			Up = 180,
			Right = -45,
			Forward = 15,
		},
	},
	Radar = {
		Pos = {
			Up = 0,
			Right = -13,
			Forward = 0,
		},
		Ang = {
			Up = -90,
			Right = 0,
			Forward = -90,
		},
	}
}

SWEP.CamData = {
	WorldModel = {
		Pos = {
			Up = 7,
			Right = 10.1,
			Forward = 7,
		},
		Ang = {
			Up = -90,
			Right = 90,
			Forward = 180,
		},
		Scale = .0225,
	},
	ViewModel = {
		Pos = {
			Up = 7,
			Right = 10.1,
			Forward = 7,
		},
		Ang = {
			Up = -90,
			Right = 90,
			Forward = 180,
		},
		Scale = .0225,
	}
}

function SWEP:DrawWorldModel( )
	local hand, offset, rotate, pos, ang
	
	pos = self:GetPos( )
	ang = self:GetAngles( )
		
	offset = ang:Right( ) * self.Offset.Radar.Pos.Right + ang:Forward( ) * self.Offset.Radar.Pos.Forward + ang:Up( ) * self.Offset.Radar.Pos.Up
		
	ang:RotateAroundAxis( ang:Right( ), self.Offset.Radar.Ang.Right )
	ang:RotateAroundAxis( ang:Forward( ), self.Offset.Radar.Ang.Forward )
	ang:RotateAroundAxis( ang:Up( ), self.Offset.Radar.Ang.Up )
		
	self.Radar:SetRenderOrigin( pos + offset )
	self.Radar:SetRenderAngles( ang )
	
	if not ValidEntity( self.Owner ) then
		self:DrawModel( )
		self.Radar:DrawModel( )
		self:DrawRadarScreen( 1 )
		return
	end
	
	if not self.Hand then
		self.Hand = self.Owner:LookupAttachment( "anim_attachment_rh" )
	end
	
	hand = self.Owner:GetAttachment( self.Hand )
	
	if not hand then
		self:DrawModel( )
		self.Radar:DrawModel( )
		self:DrawRadarScreen( 1 )
		return
	end

	offset = hand.Ang:Right( ) * self.Offset.WorldModel.Pos.Right + hand.Ang:Forward( ) * self.Offset.WorldModel.Pos.Forward + hand.Ang:Up( ) * self.Offset.WorldModel.Pos.Up
	
	hand.Ang:RotateAroundAxis( hand.Ang:Right( ), self.Offset.WorldModel.Ang.Right )
	hand.Ang:RotateAroundAxis( hand.Ang:Forward( ), self.Offset.WorldModel.Ang.Forward )
	hand.Ang:RotateAroundAxis( hand.Ang:Up( ), self.Offset.WorldModel.Ang.Up )
	
	self:SetRenderOrigin( hand.Pos + offset )
	self:SetRenderAngles( hand.Ang )
	
	self:DrawModel( )
	self.Radar:DrawModel( )
	self:DrawRadarScreen( 1 )
end

function SWEP:GetViewModelPosition( pos, ang )
	local r, u, f, n, x, y, z
	
	ang.p = math.max( ang.p, 0 )
	
	x = self.Irons.Normal.Ang.x
	y = self.Irons.Normal.Ang.y
	z = self.Irons.Normal.Ang.z
	
	ang:RotateAroundAxis( ang:Right( ), x )
	ang:RotateAroundAxis( ang:Up( ), y )
	ang:RotateAroundAxis( ang:Forward( ), z )
	
	x = self.Irons.Normal.Pos.x
	y = self.Irons.Normal.Pos.y
	z = self.Irons.Normal.Pos.z
		
	pos = pos + x * ang:Right( )
	pos = pos + y * ang:Forward( )
	pos = pos + z * ang:Up( )
	
	return pos, ang
end

function SWEP:ViewModelDrawn( )
	local vm, offset, pos, ang
	
	vm = self.Owner:GetViewModel( )
	
	if ValidEntity( self.Radar ) then
		pos = vm:GetPos( )
		ang = vm:GetAngles( )
		
		offset = ang:Right( ) * self.Offset.Radar.Pos.Right + ang:Forward( ) * self.Offset.Radar.Pos.Forward + ang:Up( ) * self.Offset.Radar.Pos.Up
		
		ang:RotateAroundAxis( ang:Right( ), self.Offset.Radar.Ang.Right )
		ang:RotateAroundAxis( ang:Forward( ), self.Offset.Radar.Ang.Forward )
		ang:RotateAroundAxis( ang:Up( ), self.Offset.Radar.Ang.Up )
		
		self.Radar:SetRenderOrigin( pos + offset )
		self.Radar:SetRenderAngles( ang )
		self.Radar:DrawModel( )
	end
	
	self:DrawRadarScreen( 0 )
end

local color_green = Color( 000, 189, 000, 255 )
local color_red = Color( 189, 000, 000, 255 )
local color_yellow = Color( 189, 189, 000, 255 )

local t = { }

function SWEP:RenderRadar( )
	local w, h, k, v, origin, dpos, cx, cy, x, y, z, theta, ang
	
	table.Empty( t )
	
	w = 715
	h = 565
	
	surface.SetDrawColor( 000, 000, 000, 200 )
	
	surface.DrawRect( 0, 0, w, h )
	
	cx = w * .5
	cy = h * .5
	
	origin = self:GetPos( )
	
	if ValidEntity( self.Owner ) then
		ang = self.Owner:GetAimVector( )
		
		surface.SetDrawColor( color_yellow )
		surface.DrawRect( cx - 3, cy - 3, 6, 6 )
	else
		ang = self:GetForward( ) * -1
	end
	
	for k, v in ipairs( ents.GetAll( ) ) do
		if not ValidEntity( v ) or not v or not v:GetModel( ) or v:GetClass( ) == "class C_BaseFlex" then
			continue
		end
		if ( ( v:IsPlayer( ) and v:Alive( ) and v ~= self.Owner ) or v:IsNPC( ) ) and v:GetPos( ):Distance( origin ) < 615 then
			table.insert( t, v )
		elseif v.HasRadar or v:GetModel( ):lower( ) == "models/props_citizen_tech/transponder.mdl" then
			table.insert( t, v )
		end
	end
	
	for k, v in ipairs( t ) do
		dpos = ( v:GetPos( ) - origin )
		
		x = dpos.x / h
		y = dpos.y / h
		z = math.sqrt( x * x + y * y )
		theta = math.rad( math.deg( math.atan2( x, y ) ) - math.deg( math.atan2( ang.x, ang.y ) ) - 90 )
		
		x = math.cos( theta ) * z
		y = math.sin( theta ) * z
		
		x = math.Clamp( x, -1, 1 )
		y = math.Clamp( y, -1, 1 )
		
		if v:IsNPC( ) then
			surface.SetDrawColor( color_red )
		elseif v:IsPlayer( ) then
			surface.SetDrawColor( color_yellow )
		elseif v.HasRadar or v:GetModel( ):lower( ) == "models/props_citizen_tech/transponder.mdl" then
			surface.SetDrawColor( color_green )
		end
		
		surface.DrawRect( cx + x * h * .35 - 3, cy + y * h * .35 - 3, 6, 6 )
	end
end

function SWEP:DrawRadarScreen( context )
	local pos, ang, offset, vm, ok, err, scale
	
	if context == 1 then
		--World model
		
		pos = self:GetPos( )
		ang = self:GetAngles( )
		
		offset = ang:Right( ) * self.CamData.WorldModel.Pos.Right + ang:Forward( ) * self.CamData.WorldModel.Pos.Forward + ang:Up( ) * self.CamData.WorldModel.Pos.Up
		
		ang:RotateAroundAxis( ang:Right( ), self.CamData.WorldModel.Ang.Right )
		ang:RotateAroundAxis( ang:Forward( ), self.CamData.WorldModel.Ang.Forward )
		ang:RotateAroundAxis( ang:Up( ), self.CamData.WorldModel.Ang.Up )
		
		pos = pos + offset
		
		scale = self.CamData.WorldModel.Scale
	else
		--View model
		vm = self.Owner:GetViewModel( )
		
		pos = vm:GetPos( )
		ang = vm:GetAngles( )
		
		offset = ang:Right( ) * self.CamData.ViewModel.Pos.Right + ang:Forward( ) * self.CamData.ViewModel.Pos.Forward + ang:Up( ) * self.CamData.ViewModel.Pos.Up
		
		ang:RotateAroundAxis( ang:Right( ), self.CamData.ViewModel.Ang.Right )
		ang:RotateAroundAxis( ang:Forward( ), self.CamData.ViewModel.Ang.Forward )
		ang:RotateAroundAxis( ang:Up( ), self.CamData.ViewModel.Ang.Up )
		
		pos = pos + offset
		
		scale = self.CamData.ViewModel.Scale
	end
	
	cam.Start3D2D( pos, ang, scale )
		ok, err = pcall( self.RenderRadar, self )
		if not ok then
			ErrorNoHalt( err .. "\n" )
		end
	cam.End3D2D( )
end

function SWEP:Initialize( )
	self:SetWeaponHoldType( "physgun" )
	
	if CLIENT then
		self.Radar = ClientsideModel( "models/props_citizen_tech/transponder.mdl", RENDERGROUP_OPAQUE )
		self.Radar:SetNoDraw( true )
	end
end

function SWEP:PrimaryAttack( )
end

function SWEP:SecondaryAttack( )
end

function SWEP:Reload( )
end